Fix "gmake -j"
[git.git] / git-am.sh
index 98a390a..98b9215 100755 (executable)
--- a/git-am.sh
+++ b/git-am.sh
@@ -1,14 +1,10 @@
 #!/bin/sh
 #
 #
-. git-sh-setup || die "Not a git archive"
 
-usage () {
-    echo >&2 "usage: $0 [--signoff] [--dotest=<dir>] [--utf8] [--3way] <mbox>"
-    echo >&2 " or, when resuming"
-    echo >&2 " $0 [--skip | --resolved]"
-    exit 1;
-}
+USAGE='[--signoff] [--dotest=<dir>] [--utf8] [--binary] [--3way] <mbox>
+  or, when resuming [--skip | --resolved]'
+. git-sh-setup
 
 stop_here () {
     echo "$1" >"$dotest/next"
@@ -40,7 +36,7 @@ fall_back_3way () {
            cd "$dotest/patch-merge-tmp-dir" &&
            GIT_INDEX_FILE="../patch-merge-tmp-index" \
            GIT_OBJECT_DIRECTORY="$O_OBJECT" \
-           git-apply --index <../patch
+           git-apply $binary --index <../patch
         )
     then
        echo Using index info to reconstruct a base tree...
@@ -71,7 +67,7 @@ fall_back_3way () {
                GIT_OBJECT_DIRECTORY="$O_OBJECT" &&
                export GIT_INDEX_FILE GIT_OBJECT_DIRECTORY &&
                git-read-tree "$base" &&
-               git-apply --index &&
+               git-apply $binary --index &&
                mv ../patch-merge-tmp-index ../patch-merge-index &&
                echo "$base" >../patch-merge-base
            ) <"$dotest/patch"  2>/dev/null && break
@@ -92,13 +88,17 @@ fall_back_3way () {
     # saying that we reverted all those changes.
 
     git-merge-resolve $orig_tree -- HEAD $his_tree || {
+           if test -d "$GIT_DIR/rr-cache"
+           then
+               git-rerere
+           fi
            echo Failed to merge in the changes.
            exit 1
     }
 }
 
 prec=4
-dotest=.dotest sign= utf8= keep= skip= interactive= resolved=
+dotest=.dotest sign= utf8= keep= skip= interactive= resolved= binary=
 
 while case "$#" in 0) break;; esac
 do
@@ -113,6 +113,9 @@ do
        --interacti|--interactiv|--interactive)
        interactive=t; shift ;;
 
+       -b|--b|--bi|--bin|--bina|--binar|--binary)
+       binary=t; shift ;;
+
        -3|--3|--3w|--3wa|--3way)
        threeway=t; shift ;;
        -s|--s|--si|--sig|--sign|--signo|--signof|--signoff)
@@ -161,17 +164,15 @@ else
        # Start afresh.
        mkdir -p "$dotest" || exit
 
-       # cat does the right thing for us, including '-' to mean
-       # standard input.
-       cat "$@" |
-       git-mailsplit -d$prec "$dotest/" >"$dotest/last" || {
+       git-mailsplit -d"$prec" -o"$dotest" -b -- "$@" > "$dotest/last" ||  {
                rm -fr "$dotest"
                exit 1
        }
 
-       # -s, -u and -k flags are kept for the resuming session after
+       # -b, -s, -u and -k flags are kept for the resuming session after
        # a patch failure.
        # -3 and -i can and must be given when resuming.
+       echo "$binary" >"$dotest/binary"
        echo "$sign" >"$dotest/sign"
        echo "$utf8" >"$dotest/utf8"
        echo "$keep" >"$dotest/keep"
@@ -187,6 +188,10 @@ case "$resolved" in
        fi
 esac
 
+if test "$(cat "$dotest/binary")" = t
+then
+       binary=--allow-binary-replacement
+fi
 if test "$(cat "$dotest/utf8")" = t
 then
        utf8=-u
@@ -210,6 +215,7 @@ this=`cat "$dotest/next"`
 if test "$skip" = t
 then
        this=`expr "$this" + 1`
+       resume=
 fi
 
 if test "$this" -gt "$last"
@@ -224,6 +230,7 @@ do
        msgnum=`printf "%0${prec}d" $this`
        next=`expr "$this" + 1`
        test -f "$dotest/$msgnum" || {
+               resume=
                go_next
                continue
        }
@@ -248,6 +255,13 @@ do
        GIT_AUTHOR_NAME="$(sed -n '/^Author/ s/Author: //p' "$dotest/info")"
        GIT_AUTHOR_EMAIL="$(sed -n '/^Email/ s/Email: //p' "$dotest/info")"
        GIT_AUTHOR_DATE="$(sed -n '/^Date/ s/Date: //p' "$dotest/info")"
+
+       if test -z "$GIT_AUTHOR_EMAIL"
+       then
+               echo "Patch does not have a valid e-mail address."
+               stop_here $this
+       fi
+
        export GIT_AUTHOR_NAME GIT_AUTHOR_EMAIL GIT_AUTHOR_DATE
 
        SUBJECT="$(sed -n '/^Subject/ s/Subject: //p' "$dotest/info")"
@@ -304,7 +318,7 @@ do
                echo "--------------------------"
                cat "$dotest/final-commit"
                echo "--------------------------"
-               echo -n "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
+               printf "Apply? [y]es/[n]o/[e]dit/[v]iew patch/[a]ccept all "
                read reply
                case "$reply" in
                [yY]*) action=yes ;;
@@ -339,7 +353,7 @@ do
 
        case "$resolved" in
        '')
-               git-apply --index "$dotest/patch"
+               git-apply $binary --index "$dotest/patch"
                apply_status=$?
                ;;
        t)